member
_ABCDllMode_  EQUATE(0)
_ABCLinkMode_ EQUATE(1)

 Map
   module('api')
     lstrcpy(long,long),long,proc,pascal,raw,name('lStrCpyA')
     ShGetSpecialFolderLocation(unsigned hwnd, long specialLocation, *long lpPidl),pascal,long,proc
     ShGetPathFromIDList(long lpPidl, *cstring szPath),pascal,long,proc,raw,name('ShGetPathFromIDListA')
   end
 end

!Includes this class and others
 include('Scut.inc')

!global data for this module
Return:benign equate(0)
Return:Fatal  equate(3)
Return:Notify equate(5)

!Equates for Interfaces
!1-19 is reserved for hOleCl interfaces
    Itemize(20)
    !List all interfaces called here
IShellLink   Equate
IPersistFile Equate
    end

!Vtable Offset - List all methods called
!Method           equate(Interface*100H      + 0CH)
IShellLink_SetDescrip           Equate(IShellLink*100H + 1CH)
IShellLink_SetWorkDir           Equate(IShellLInk*100H + 24H)
IShellLink_SetArguments         Equate(IShellLink*100H + 2CH)
IShellLink_SetHotKey            Equate(IShellLink*100H + 34H)
IShellLink_SetIconLoc           Equate(IShellLink*100H + 44H)
IShellLink_SetPath              Equate(IShellLink*100H + 50H)

IPersistFile_Save               equate(IPersistFile*100H + 18H)
   

!List of IIDS, and CLSIDS
IID_IShellLink   group
data1       ulong(214EEH)
data2       ushort(0)
data3       ushort(0)
data41      byte(0C0H)
data42      byte(0)
data43      byte(0)
data44      byte(0)
data45      byte(0)
data46      byte(0)
data47      byte(0)
data48      byte(46H)
  end
IID_IPersistFile   group
data1       ulong(10BH)
data2       ushort(0)
data3       ushort(0)
data41      byte(0C0H)
data42      byte(0)
data43      byte(0)
data44      byte(0)
data45      byte(0)
data46      byte(0)
data47      byte(0)
data48      byte(46H)
  end

!CLSID_xxxxx
ClsId_IShellLink Group
data1       ulong(21401H)
data2       ushort(0)
data3       ushort(0)
data41      byte(0C0H)
data42      byte(0)
data43      byte(0)
data44      byte(0)
data45      byte(0)
data46      byte(0)
data47      byte(0)
data48      byte(46H)
  end


!-------------------------------------------------------------
!---Start of ScutClTyp class
!-------------------------------------------------------------
ScutClType.Init                Procedure(byte pDebugMode=0) !,byte,proc
Res byte,auto
    code
    Clear(SELF)
    res = Parent.Init(pDebugMode)
    If ~Res then
       SELF.AddIID(IShellLink,Address(IID_IShellLink),'IShellLink')
       SELF.AddIID(IPersistFile, Address(IID_IPersistFile),'IPersistFile')
       SELF.AddMethodName(IShellLink_SetPath,'IShellLink_SetPath')
       SELF.AddMethodName(IShellLink_SetIconLoc,'IShellLink_SetIconLoc')
       SELF.AddMethodName(IShellLink_SetDescrip,'IShellLink_SetDescrip')
       SELF.AddMethodName(IShellLink_SetHotkey,'IShellLink_SetHotKey')
       SELF.AddMethodName(IShellLink_SetWorkDir,'IShellLink_SetWorkDir')
       SELF.AddMethodName(IPersistFile_Save,'IPersistFile_Save')
    end
    Return(Res)
ScutClType.Kill      Procedure()
  code
  Parent.Kill()
  Return

ScutClType.CreateShortCut      Procedure(ShortCutStructType SCS) !,byte
LinkFileName            cstring(File:MaxFilePath)
szPath                  cstring(File:MaxFilePath)
wszLinkFile             &String
Res                     byte,auto
lpPidl                  long,auto
HR                      long,auto

  Code
   !Validate the required data pointers, see if a special location is used
   if ~SCS.lpTarget or ~SCS.lpIconPath or ~SCS.lpLinkFileName then
     Return(Return:Notify)
   end
   lstrcpy(Address(LinkFileName),SCS.lpLinkFileName)
   If Instring('\',LinkFileName,1,1) or Instring(':',LinkFileName,1,1) then
     !LinkFileName includes a path
     SCS.SpecialLocation=-1
   end

   !Get the IShellLink Interface with CoCreate
   If SELF.CoCreate(Address(Clsid_IShellLink), IShellLink) then return(Return:Fatal).

   !Get Ipersist_File from QueryInterface
   If SELF.QueryInterface(IShellLink, Address(IID_IPersistFile), IPersistFile ) then Return(Return:Fatal).

   !Set Short Cut Attributes
   If SELF.ICall(1, IShellLink, IShellLink_SetPath, SCS.lpTarget) Then Return(Return:Fatal).
   If SELF.ICall(2, IShellLink, IShellLink_SetIconLoc, SCS.lpIconPath, SCS.IconIndex) Then Return(Return:Fatal).
   If SCS.lpDesc then
     If SELF.ICall(1, IShellLink, IShellLink_SetDescrip, SCS.lpDesc) Then Return(Return:Fatal).
   end
   If SCS.hotkey then
     If SELF.ICall(1,IShellLink, IShellLink_SetHotKey, SCS.HotKey) Then Return(Return:Fatal).
   end
   If SCS.lpWorkingDir then
     If SELF.ICall(1,IShellLink, IShellLink_SetWorkDir, SCS.lpWorkingDir) Then Return(Return:Fatal).
   end

    !Now all that is left is saving the .lnk file to disk and telling windows
    ! if it should go in a conventional path or a SpecialLocation like the desktop
    If SCS.SpecialLocation<0 then
       !It's just a normal file/path so copy it to szPath
       szPath = LinkFileName
    Else
       !Lets ask the shell what the special location's Path is:
       !PILD = pointer to a Identifier List
       hr = ShGetSpecialFolderLocation(0,SCS.SpecialLocation,lppidl)
       If hr<0 then
         Return(Return:Fatal)
       end

       !Now get a path from the pidl
       Hr = ShGetPathFromIDList(lpPidl,szPath)
       If hr<0 then
         Return(Return:Fatal)
       end

       !put the path we just got together with the working directory
       If sub(szPath,-1,1)<>'\' then
         szPath = szPath & '\' & LinkFileName
       Else
         szPath = szPath & LinkFileName
       end
    end


    !Either way szPath is now the cstring where we want to store things
    !Now convert to a wide string
    wszLinkFile &= SELF.StrCl.CtoWideStrAlloc(szPath)

    !Last but not least, save the shortcut to disk then cleanup and exit:
    Res = SELF.ICall(2,IPersistFile, IPersistFile_Save, Address(wszLinkFile), True)
    Dispose(wszLinkFile)
    If res then Return Return:Fatal.

  Return Return:Benign